package matsubara.gear;

import java.awt.Color;
import java.awt.Graphics;



/**
 * ^Cg:  Planetary Gear
 * :    vl^MApėpNX
 * <p>쌠: Copyright (c) 2002 matsubara masakazu </p>
 * @author m.matsubara
 * @version 1.0
 */
public class PlanetaryGear extends GearBase {
  Gear             m_ringGear;
  PlanetaryCarrier m_plaCarrier;
  Gear             m_sunGear;
  Gear             mx_piniGear[];

  double m_rRingGearSpeed = 0;
  double m_rPlaCarrierSpeed = 0;

  /**
   * vl^MA
   * @param nX XW
   * @param nY YW
   * @param nSize a
   * @param nSunGear TMA̎
   * @param nPinionGear sjIMA̎ivl^LA4tj
   * @param nRingGear OMA̎
   * @param nGearDepth MA̎̐[
   * @param nPinionGearNumber sjIMǍiʏ͂RȏɂĂj
   * @throws EPlanetaryGear vl^MA̐ɈᔽƂO𔭐
   */
  public PlanetaryGear(int nX, int nY, int nSize, int nSunGear, int nPinionGear, int nRingGear, int nGearDepth, int nPinionGearNumber) throws EPlanetaryGear {
    double rPinionGearSize = (nRingGear - nSunGear) / 2 * nSize / nRingGear / 2;
    double rPlanetaryCarrierSize = nSunGear * nSize / nRingGear + rPinionGearSize;

    mx_piniGear = new Gear[nPinionGearNumber];

    gearCheck(nSunGear, nRingGear, rPinionGearSize, nPinionGearNumber, nGearDepth, rPlanetaryCarrierSize);

    m_ringGear   = new RingGear(        nX, nY, nRingGear * nSize / nRingGear,   nRingGear, nGearDepth);
    m_sunGear    = new Gear(            nX, nY, nSunGear * nSize / nRingGear   , nSunGear   , nGearDepth);
    m_plaCarrier = new PlanetaryCarrier(nX, nY, (int)rPlanetaryCarrierSize);
    //  sjIMA
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++) {
      mx_piniGear[nIdx] = new Gear(0, 0, rPinionGearSize, nPinionGear, nGearDepth);
      mx_piniGear[nIdx].setColor1(Color.orange);
      mx_piniGear[nIdx].setColor2(Color.darkGray);
      //  px␳
      mx_piniGear[nIdx].setAngle((2 * Math.PI) * nIdx / mx_piniGear.length
        + (2 * Math.PI) / mx_piniGear[nIdx].getGearCount() / 2
        - (2 * Math.PI) / mx_piniGear[nIdx].getGearCount() * (m_ringGear.getGearCount() % nPinionGearNumber) * nIdx / nPinionGearNumber
      );
    }

    move(0);  //  sjIMA𐳂ʒuɔzu邽

    //  vl^LA̐F
    m_plaCarrier.setColor2(Color.red);
    //  TMA̐F
    m_sunGear.setColor2(Color.blue);
    //  OMA̐F
    m_ringGear.setColor2(new Color(0, 0xbb, 0));

    m_plaCarrier.setWidth((int)(mx_piniGear[0].getSize()));

    if (nPinionGear % 2 == 1)
      m_sunGear.setAngle(2 * Math.PI / (m_sunGear.getGearCount() * 2));
  }


  /**
   * Ԃ̎Ȃǂɖ肪Ȃ`FbN
   * @param nSunGear TMÃTCY
   * @param nRingGear OMÃTCY
   * @param rPinionGearSize sjIMÃTCY
   * @param nPinionGearNumber sjIMǍ
   * @param nGearDepth t̐[
   * @param rPlanetaryCarrierSize vl^LÃTCY
   * @throws EPlanetaryGear p[^ɖ肪ꍇɗO𐶐
   */
  public void gearCheck(int nSunGear, int nRingGear, double rPinionGearSize, int nPinionGearNumber, int nGearDepth, double rPlanetaryCarrierSize) throws EPlanetaryGear {
    if (rPinionGearSize * 2 + nGearDepth >= 2 * rPlanetaryCarrierSize * Math.sin(Math.PI / nPinionGearNumber))
      throw new EPlanetaryGear("sjIMAmԂ荇܂B");
    if ((nRingGear + nSunGear) % nPinionGearNumber != 0)
      throw new EPlanetaryGear("Ԃݍ܂B");
    if (nRingGear <= nSunGear)
      throw new EPlanetaryGear("OMA̓TMA傫Ȃ΂Ȃ܂B");
  }

  /**
   * vl^MA`
   * @param g `Ɏg Graphics IuWFNg
   */
  public void draw(Graphics g) {
    m_ringGear.draw(g);
    m_plaCarrier.draw(g);
    m_sunGear.draw(g);
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++)
      mx_piniGear[nIdx].draw(g);
  }

  /**
   * ݒ肳ĂMAXs[hŎԂ]
   * d@]iGW]~iNMATCY{TMATCYj|[^[]~NMATCYjTMATCY
   * @param nMilliSec oߕb
   */
  public void move(double nMilliSec) {
    int nRingGearCount = m_ringGear.getGearCount();
    int nSunGearCount = m_sunGear.getGearCount();
    double rPlanetaryCarrierSize = (m_sunGear.getSize() + m_ringGear.getSize()) / 2;
    double rSunGearSpeed = (m_rPlaCarrierSpeed * (nRingGearCount + nSunGearCount) - m_rRingGearSpeed * nRingGearCount) / (double)nSunGearCount;

    m_sunGear.setAngle(m_sunGear.getAngle() + rSunGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_plaCarrier.setAngle(m_plaCarrier.getAngle() + m_rPlaCarrierSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    m_ringGear.setAngle(m_ringGear.getAngle() + m_rRingGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);

    //  sjIMA
    double rPinionGearSpeed = m_rPlaCarrierSpeed + (m_rRingGearSpeed - m_rPlaCarrierSpeed) * m_ringGear.getGearCount() / mx_piniGear[0].getGearCount();
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++) {
      //  ʒu
      mx_piniGear[nIdx].setPosX(m_plaCarrier.rotateX(rPlanetaryCarrierSize, (2 * Math.PI) * nIdx / mx_piniGear.length));
      mx_piniGear[nIdx].setPosY(m_plaCarrier.rotateY(rPlanetaryCarrierSize, (2 * Math.PI) * nIdx / mx_piniGear.length));
      //  ]
      mx_piniGear[nIdx].setAngle(mx_piniGear[nIdx].getAngle() + rPinionGearSpeed / 60 / 1000 * nMilliSec * 2 * Math.PI);
    }
  }

  /**
   * OMẢ]ݒ肷
   * OMẢ]ɂ킹ăTMẢ]ω
   * @param rRingGearSpeed VOMẢ](rpm)
   */
  public void setRingGearSpeed(double rRingGearSpeed) {
    m_rRingGearSpeed = rRingGearSpeed;
  }
  /**
   * OMẢ]擾
   * @return OMẢ](rpm)
   */
  public double getRingGearSpeed() {
    return m_rRingGearSpeed;
  }
  /**
   * vl^LẢ]ݒ肷
   * vl^LẢ]ɂ킹ăTMẢ]ω
   * @param rPlaCarrierSpeed Vvl^MẢ](rpm)
   */
  public void setPlaCarrierSpeed(double rPlaCarrierSpeed) {
    m_rPlaCarrierSpeed = rPlaCarrierSpeed;
  }
  /**
   * vl^LẢ]擾
   * @return vl^LẢ](rpm)
   */
  public double getPlaCarrierSpeed() {
    return m_rPlaCarrierSpeed;
  }

  /**
   * TMẢ]擾
   * @return TMẢ](rpm)
   */
  public double getSunGearSpeed() {
    double rRingGearCount = m_ringGear.getGearCount();
    double rSunGearCount = m_sunGear.getGearCount();
    return (m_rPlaCarrierSpeed * (rRingGearCount + rSunGearCount) - m_rRingGearSpeed * rRingGearCount) / rSunGearCount;
  }

  /**
   * TMẢ]ݒ
   * TMẢ]ɂ킹ăvl^LẢ]ω
   * @param rSunGearSpeed VTMẢ](rpm)
   */
  public void setSunGearSpeed(double rSunGearSpeed) {
    double rRingGearCount = m_ringGear.getGearCount();
    double rSunGearCount = m_sunGear.getGearCount();
    setPlaCarrierSpeed((int)((rSunGearSpeed * rSunGearCount + m_rRingGearSpeed * rRingGearCount) / (rRingGearCount + rSunGearCount)));
  }

  /**
   * OMA擾
   * @return OMA
   */
  public Gear getRingGear() {
    return m_ringGear;
  }
  /**
   * vl^LA擾
   * @return vl^LA
   */
  public PlanetaryCarrier getPlanetaryCarrier() {
    return m_plaCarrier;
  }
  /**
   * TMA擾
   * @return TMA
   */
  public Gear getSunGear() {
    return m_sunGear;
  }

  /**
   * vl^MAXWݒ
   * @param nX XW
   */
  public void setPosX(int nX) {
    super.setPosX(nX);
    m_ringGear.setPosX(nX);
    m_plaCarrier.setPosX(nX);
    m_sunGear.setPosX(nX);
    move(0);
  }

  /**
   * vl^MAYWݒ
   * @param nY YW
   */
  public void setPosY(int nY) {
    super.setPosY(nY);
    m_ringGear.setPosY(nY);
    m_plaCarrier.setPosY(nY);
    m_sunGear.setPosY(nY);
    move(0);
  }

  /**
   * vl^MÃTCYiajݒ
   * @param nSize a
   */
  public void setSize(double rSize) {
    super.setSize(rSize);
    m_ringGear.setSize(rSize);
    m_sunGear.setSize(rSize * m_sunGear.getGearCount() / m_ringGear.getGearCount());
    for (int nIdx = 0; nIdx < mx_piniGear.length; nIdx++)
      mx_piniGear[nIdx].setSize((m_ringGear.getSize() - m_sunGear.getSize()) / 2);
    m_plaCarrier.setWidth((int)(m_ringGear.getSize() - m_sunGear.getSize()) / 2);
    m_plaCarrier.setSize(m_sunGear.getSize() * rSize / m_ringGear.getSize() + mx_piniGear[0].getSize());
    move(0);
  }
}